
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Voyager.Actions.ShiftFieldRefinement &#8212; PhaserVoyager 0.0.1 documentation</title>
    <link rel="stylesheet" href="../../../_static/sphinxdoc.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" accesskey="U">Module code</a> &#187;</li> 
      </ul>
    </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for Voyager.Actions.ShiftFieldRefinement</h1><div class="highlight"><pre>
<span></span>
<span class="c1">#! /usr/bin/env python</span>
<span class="c1"># -*- coding: utf-8 -*-</span>

<span class="c1">#####################################################################</span>
<span class="c1">#  Copyright and authorship belong to:                              #</span>
<span class="c1">#  @author: Massimo Sammito                                         #</span>
<span class="c1">#  @email: mds83@cam.ac.uk / massimo.sammito@gmail.com              #</span>
<span class="c1">#####################################################################</span>
<span class="c1">#####################################################################</span>
<span class="c1">#                              LICENSE                              #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#####################################################################</span>

<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">print_function</span>
<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">division</span>
<span class="kn">from</span> <span class="nn">future.standard_library</span> <span class="kn">import</span> <span class="n">install_aliases</span>
<span class="kn">from</span> <span class="nn">libtbx.phil</span> <span class="kn">import</span> <span class="n">parse</span>

<span class="n">install_aliases</span><span class="p">()</span>

<span class="kn">import</span> <span class="nn">sys</span><span class="o">,</span><span class="nn">os</span><span class="o">,</span><span class="nn">copy</span>
<span class="kn">import</span> <span class="nn">traceback</span>
<span class="kn">import</span> <span class="nn">networkx</span> <span class="k">as</span> <span class="nn">nx</span>
<span class="kn">from</span> <span class="nn">voyager_actions</span> <span class="kn">import</span> <span class="n">Action</span>
<span class="kn">import</span> <span class="nn">shutil</span>

<span class="kn">import</span> <span class="nn">phaser_wrapper</span>
<span class="kn">import</span> <span class="nn">shift_field_refinement</span>

<span class="c1">#DISCLAIMER#</span>
<span class="c1">#This class has been generated automatically through strategy_app.py</span>
<span class="c1">#The app does not verify the correctness of the written code</span>
<span class="c1">#Please validate the class before use and manually inspect and correct any error</span>

<div class="viewcode-block" id="ShiftFieldRefinement_exception"><a class="viewcode-back" href="../../../Voyager.Actions.ShiftFieldRefinement.html#Voyager.Actions.ShiftFieldRefinement.ShiftFieldRefinement_exception">[docs]</a><span class="k">class</span> <span class="nc">ShiftFieldRefinement_exception</span><span class="p">(</span><span class="ne">Exception</span><span class="p">):</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">msg</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">ShiftFieldRefinement_exception</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">msg</span><span class="p">)</span></div>
        
<div class="viewcode-block" id="ShiftFieldRefinement"><a class="viewcode-back" href="../../../Voyager.Actions.ShiftFieldRefinement.html#Voyager.Actions.ShiftFieldRefinement.ShiftFieldRefinement">[docs]</a><span class="k">class</span> <span class="nc">ShiftFieldRefinement</span><span class="p">(</span><span class="n">Action</span><span class="p">):</span>
    <span class="n">info_dag_nodes</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;hkl_input&quot;</span><span class="p">:</span><span class="s2">&quot;*&quot;</span><span class="p">,</span><span class="s2">&quot;hkl_output&quot;</span><span class="p">:</span><span class="s2">&quot;*&quot;</span><span class="p">,</span><span class="s2">&quot;model_input&quot;</span><span class="p">:</span><span class="s2">&quot;*&quot;</span><span class="p">,</span><span class="s2">&quot;model_output&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">,</span><span class="s2">&quot;occurrences&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">}</span>
    <span class="n">rule</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;[[&quot;PrepareMR&quot;]]&quot;&quot;&quot;</span>
    <span class="n">phasertngphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;&quot;&quot;&quot;</span>
    <span class="n">masterphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;voyager.ShiftFieldRefinement {</span>
<span class="s2">max_rmsd_from_shift = 1.5</span>
<span class="s2">  .type = float</span>
<span class="s2">  .expert_level = 0</span>
<span class="s2">  .optional = True</span>
<span class="s2">  .short_caption = Maximum rmsd acceptable after shift</span>
<span class="s2">  .help = Maximum rmsd acceptable after performing a shift field refinement</span>
<span class="s2">  </span>
<span class="s2">}&quot;&quot;&quot;</span>
    <span class="n">helpstring</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot; Performs shift field refinement for each model in the ensemble representing a partial or complete solution for the molecular replacement job.&quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">strategy</span><span class="p">,</span> <span class="n">current_phil_keywords</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="s1">&#39;ShiftFieldRefinement&#39;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span> <span class="o">=</span> <span class="n">strategy</span><span class="o">.</span><span class="n">arguments</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">ShiftFieldRefinement</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">strategy</span><span class="p">,</span> <span class="n">current_phil_keywords</span><span class="p">)</span>
        
        
<div class="viewcode-block" id="ShiftFieldRefinement.check_imports"><a class="viewcode-back" href="../../../Voyager.Actions.ShiftFieldRefinement.html#Voyager.Actions.ShiftFieldRefinement.ShiftFieldRefinement.check_imports">[docs]</a>    <span class="k">def</span> <span class="nf">check_imports</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">b</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">test</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;test() method has not been implemented!&quot;</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">c</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">help</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;help() method has not been implemented!&quot;</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">d</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_name</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;get_name() method has not been implemented!&quot;</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">iotbx</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;iotbx&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">simple_tools</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;simple_tools&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">pdb_structure</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;pdb_structure&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">any_file</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;iotbx.file_reader&quot;</span><span class="p">,</span> <span class="n">fromlist</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;any_file&quot;</span><span class="p">])</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">system_utility</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;system_utility&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">np</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;numpy&quot;</span><span class="p">)</span>

        <span class="k">return</span> <span class="kc">True</span></div>

<div class="viewcode-block" id="ShiftFieldRefinement.test"><a class="viewcode-back" href="../../../Voyager.Actions.ShiftFieldRefinement.html#Voyager.Actions.ShiftFieldRefinement.ShiftFieldRefinement.test">[docs]</a>    <span class="k">def</span> <span class="nf">test</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="c1">#TODO: perform a complete self contained test</span>
        <span class="k">pass</span></div>
    
<div class="viewcode-block" id="ShiftFieldRefinement.help"><a class="viewcode-back" href="../../../Voyager.Actions.ShiftFieldRefinement.html#Voyager.Actions.ShiftFieldRefinement.ShiftFieldRefinement.help">[docs]</a>    <span class="k">def</span> <span class="nf">help</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">helpstring</span></div>
    
<div class="viewcode-block" id="ShiftFieldRefinement.get_name"><a class="viewcode-back" href="../../../Voyager.Actions.ShiftFieldRefinement.html#Voyager.Actions.ShiftFieldRefinement.ShiftFieldRefinement.get_name">[docs]</a>    <span class="k">def</span> <span class="nf">get_name</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span></div>
    
<div class="viewcode-block" id="ShiftFieldRefinement.run"><a class="viewcode-back" href="../../../Voyager.Actions.ShiftFieldRefinement.html#Voyager.Actions.ShiftFieldRefinement.ShiftFieldRefinement.run">[docs]</a>    <span class="k">def</span> <span class="nf">run</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">notify_start</span><span class="p">()</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;logger&quot;</span><span class="p">):</span> <span class="k">raise</span> <span class="n">ShiftFieldRefinement_exception</span><span class="p">(</span><span class="s2">&quot;Logger File has not been set. Please call &#39;set_logger_file&#39; method before run&quot;</span><span class="p">)</span>
        <span class="n">user_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">python_object</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">)</span>
        <span class="n">diffuser_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch_diff</span><span class="p">(</span><span class="n">source</span><span class="o">=</span><span class="n">user_phil</span><span class="p">)</span>
        <span class="n">action_phil</span> <span class="o">=</span> <span class="n">parse</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">current_phil_keywords</span><span class="p">)</span>
        <span class="n">diffaction_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch_diff</span><span class="p">(</span><span class="n">source</span><span class="o">=</span><span class="n">action_phil</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch</span><span class="p">(</span><span class="n">sources</span><span class="o">=</span><span class="p">[</span><span class="n">diffaction_phil</span><span class="p">,</span><span class="n">diffuser_phil</span><span class="p">])</span><span class="o">.</span><span class="n">extract</span><span class="p">()</span>
        <span class="n">output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">shift_field_refinement</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">notify_end</span><span class="p">()</span>
        <span class="k">return</span> <span class="n">output</span></div>

<div class="viewcode-block" id="ShiftFieldRefinement.shift_field_refinement"><a class="viewcode-back" href="../../../Voyager.Actions.ShiftFieldRefinement.html#Voyager.Actions.ShiftFieldRefinement.ShiftFieldRefinement.shift_field_refinement">[docs]</a>    <span class="k">def</span> <span class="nf">shift_field_refinement</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">argsparse</span><span class="p">):</span>
        <span class="n">root</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">initial_dag_nodes</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">root</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span> <span class="n">root</span> <span class="o">=</span> <span class="p">[</span><span class="n">root</span><span class="p">]</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">root</span><span class="p">)</span> <span class="o">&lt;</span> <span class="mi">1</span><span class="p">:</span>
            <span class="k">raise</span> <span class="n">ShiftFieldRefinement_exception</span><span class="p">(</span><span class="s2">&quot;This action cannot be the root of a PhaserDAG&quot;</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">accepted_errors</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">SOLVED_LLG</span> <span class="o">=</span> <span class="mi">80</span>

        <span class="n">return_nodes</span> <span class="o">=</span> <span class="p">[]</span>

        <span class="n">mtz</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">reflections</span>
        <span class="k">if</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">labin</span><span class="o">.</span><span class="n">i</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">lab_if</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">labin</span><span class="o">.</span><span class="n">i</span>
            <span class="n">lab_sigif</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">labin</span><span class="o">.</span><span class="n">sigi</span>
            <span class="n">intensities</span> <span class="o">=</span> <span class="kc">True</span>
        <span class="k">elif</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">labin</span><span class="o">.</span><span class="n">f</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">lab_if</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">labin</span><span class="o">.</span><span class="n">f</span>
            <span class="n">lab_sigif</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">labin</span><span class="o">.</span><span class="n">sigf</span>
            <span class="n">intensities</span> <span class="o">=</span> <span class="kc">False</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">lab_if</span> <span class="o">=</span> <span class="s2">&quot;I&quot;</span>
            <span class="n">lab_sigif</span> <span class="o">=</span> <span class="s2">&quot;SIGI&quot;</span>
            <span class="n">intensities</span> <span class="o">=</span> <span class="kc">True</span>

        <span class="k">for</span> <span class="n">ele</span> <span class="ow">in</span> <span class="n">root</span><span class="p">:</span>
            <span class="n">mw</span> <span class="o">=</span> <span class="kc">None</span>
            <span class="n">basedir</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">simple_tools</span><span class="o">.</span><span class="n">create_directory_timestamp</span><span class="p">(</span><span class="s2">&quot;shiftfield_&quot;</span><span class="p">)</span>
            <span class="n">datanode</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">get_most_recent_node_with_hkl_data</span><span class="p">(</span><span class="n">ele</span><span class="p">)</span>
            <span class="c1">#solutionode = sorted([x for x in self.voyager_dag.get_all_nodes_with_pdb_model(ele, label=&quot;mr_solution&quot;, label_start_with=True)], key=lambda c: self.voyager_dag.nodes(c)[&quot;rank&quot;], reverse=True)[0]</span>
            <span class="n">solutionodep</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">get_most_recent_node_with_pdb_model</span><span class="p">(</span><span class="n">ele</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s2">&quot;mr_solution&quot;</span><span class="p">,</span> <span class="n">label_start_with</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
            <span class="n">solutionode</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">predecessors</span><span class="p">(</span><span class="n">solutionodep</span><span class="p">)][</span><span class="mi">0</span><span class="p">]</span>
            <span class="n">solutionpdbnode</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">([</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">descendants</span><span class="p">(</span><span class="n">solutionode</span><span class="p">)</span> <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">x</span><span class="p">)[</span><span class="s2">&quot;type&quot;</span><span class="p">]</span> <span class="o">==</span> <span class="s2">&quot;pdb&quot;</span><span class="p">],</span>
                   <span class="n">key</span><span class="o">=</span><span class="k">lambda</span> <span class="n">c</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">c</span><span class="p">)[</span><span class="s2">&quot;probability&quot;</span><span class="p">],</span> <span class="n">reverse</span><span class="o">=</span><span class="kc">True</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>
            <span class="n">solutionode</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">predecessors</span><span class="p">(</span><span class="n">solutionpdbnode</span><span class="p">)][</span><span class="mi">0</span><span class="p">]</span>
            <span class="n">solutionpdbmtz</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">schedule_extract_from_db</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">solutionpdbnode</span><span class="p">)[</span><span class="s2">&quot;model_identifier&quot;</span><span class="p">],</span> <span class="n">where</span><span class="o">=</span><span class="n">basedir</span><span class="p">)</span>
            <span class="n">solutionpdb</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">solutionpdbmtz</span> <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">x</span><span class="p">)</span><span class="o">.</span><span class="n">endswith</span><span class="p">(</span><span class="s2">&quot;.pdb&quot;</span><span class="p">)][</span><span class="mi">0</span><span class="p">]</span>
            <span class="n">solutionmtz</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">solutionpdbmtz</span> <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">x</span><span class="p">)</span><span class="o">.</span><span class="n">endswith</span><span class="p">(</span><span class="s2">&quot;.mtz&quot;</span><span class="p">)]</span>
            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">solutionmtz</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                <span class="n">solutionmtz</span> <span class="o">=</span> <span class="n">solutionmtz</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">solutionmtz</span> <span class="o">=</span> <span class="kc">None</span>
            <span class="n">dictiosol</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">solutionode</span><span class="p">)[</span><span class="s2">&quot;data&quot;</span><span class="p">]</span>

            <span class="k">if</span> <span class="n">dictiosol</span><span class="p">[</span><span class="s2">&quot;llg&quot;</span><span class="p">]</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                <span class="n">resultpdb</span><span class="p">,</span><span class="n">resultmtz</span><span class="p">,</span><span class="n">llg</span><span class="p">,</span><span class="n">zscore</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">perform_shift_field_refinement</span><span class="p">(</span><span class="n">argsparse</span><span class="p">,</span> <span class="n">basedir</span><span class="p">,</span> <span class="n">solutionpdb</span><span class="p">,</span> <span class="n">solutionmtz</span><span class="p">,</span> <span class="n">dictiosol</span><span class="p">,</span> <span class="n">mtz</span><span class="p">,</span> <span class="n">lab_if</span><span class="p">,</span> <span class="n">lab_sigif</span><span class="p">,</span> <span class="n">intensities</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">resultpdb</span> <span class="o">=</span> <span class="kc">None</span>

            <span class="k">if</span> <span class="n">resultpdb</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                 <span class="n">n</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">schedule_add_node_model</span><span class="p">([</span><span class="n">resultpdb</span><span class="p">,</span><span class="n">resultmtz</span><span class="p">],</span> <span class="s2">&quot;shifted::&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="s2">&quot;</span><span class="si">%.1f</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="n">llg</span><span class="p">),</span> <span class="p">{</span><span class="s2">&quot;zscore&quot;</span><span class="p">:</span><span class="n">zscore</span><span class="p">,</span> <span class="s2">&quot;llg&quot;</span><span class="p">:</span><span class="n">llg</span><span class="p">,</span> <span class="s2">&quot;mw&quot;</span><span class="p">:</span><span class="n">dictiosol</span><span class="p">[</span><span class="s2">&quot;mw&quot;</span><span class="p">],</span> <span class="s2">&quot;nc&quot;</span><span class="p">:</span><span class="n">dictiosol</span><span class="p">[</span><span class="s2">&quot;nc&quot;</span><span class="p">],</span> <span class="s2">&quot;spacegroup&quot;</span><span class="p">:</span><span class="n">dictiosol</span><span class="p">[</span><span class="s2">&quot;spacegroup&quot;</span><span class="p">]},</span> <span class="n">solutionode</span><span class="p">,</span>
                                                  <span class="bp">self</span><span class="o">.</span><span class="n">associated_strategy_node</span><span class="p">,</span> <span class="n">probability</span><span class="o">=</span><span class="n">llg</span><span class="p">,</span> <span class="n">rank</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">solution</span><span class="o">=</span><span class="kc">True</span><span class="p">)[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
                 <span class="n">return_nodes</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">n</span><span class="p">)</span>

            <span class="n">shutil</span><span class="o">.</span><span class="n">rmtree</span><span class="p">(</span><span class="n">basedir</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">return_nodes</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">root</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">return_nodes</span></div>

<div class="viewcode-block" id="ShiftFieldRefinement.perform_shift_field_refinement"><a class="viewcode-back" href="../../../Voyager.Actions.ShiftFieldRefinement.html#Voyager.Actions.ShiftFieldRefinement.ShiftFieldRefinement.perform_shift_field_refinement">[docs]</a>    <span class="k">def</span> <span class="nf">perform_shift_field_refinement</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">argsparse</span><span class="p">,</span> <span class="n">basedir</span><span class="p">,</span> <span class="n">solutionpdb</span><span class="p">,</span> <span class="n">solutionmtz</span><span class="p">,</span> <span class="n">dictiosol</span><span class="p">,</span> <span class="n">mtz</span><span class="p">,</span> <span class="n">lab_if</span><span class="p">,</span> <span class="n">lab_sigif</span><span class="p">,</span> <span class="n">intensities</span><span class="p">):</span>
        <span class="n">MAX_TRESHOLD_RMSD</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">ShiftFieldRefinement</span><span class="o">.</span><span class="n">max_rmsd_from_shift</span>
        <span class="n">shiftedpdb</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">basedir</span><span class="p">,</span> <span class="s2">&quot;shifted.pdb&quot;</span><span class="p">)</span>

        <span class="n">label1</span> <span class="o">=</span> <span class="n">lab_if</span>
        <span class="n">label2</span> <span class="o">=</span> <span class="n">lab_sigif</span>

        <span class="n">inputs</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;workingdir&quot;</span><span class="p">:</span><span class="n">basedir</span><span class="p">,</span> <span class="s2">&quot;jobname&quot;</span><span class="p">:</span><span class="s2">&quot;shift_rnp&quot;</span><span class="p">,</span> <span class="s2">&quot;mtz&quot;</span><span class="p">:</span> <span class="n">mtz</span><span class="p">,</span> <span class="s2">&quot;mw&quot;</span><span class="p">:</span> <span class="n">dictiosol</span><span class="p">[</span><span class="s2">&quot;mw&quot;</span><span class="p">],</span> <span class="s2">&quot;nc&quot;</span><span class="p">:</span> <span class="n">dictiosol</span><span class="p">[</span><span class="s2">&quot;nc&quot;</span><span class="p">],</span> <span class="s2">&quot;I-F&quot;</span><span class="p">:</span> <span class="n">label1</span><span class="p">,</span> <span class="s2">&quot;SIGI-SIGF&quot;</span><span class="p">:</span> <span class="n">label2</span><span class="p">,</span>
                  <span class="s2">&quot;intensities&quot;</span><span class="p">:</span> <span class="n">intensities</span><span class="p">,</span> <span class="s2">&quot;mute&quot;</span><span class="p">:</span><span class="kc">True</span><span class="p">,</span> <span class="s2">&quot;new_spacegroup&quot;</span><span class="p">:</span><span class="n">dictiosol</span><span class="p">[</span><span class="s2">&quot;spacegroup&quot;</span><span class="p">],</span> <span class="s2">&quot;sol&quot;</span><span class="p">:[]}</span>

        <span class="n">reflections</span> <span class="o">=</span> <span class="n">phaser_wrapper</span><span class="o">.</span><span class="n">start_MR_DAT</span><span class="p">(</span><span class="n">inputs</span><span class="p">)</span>
        <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;reflections&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">reflections</span>

        <span class="n">structure_solved</span> <span class="o">=</span> <span class="kc">False</span>
        <span class="n">direp</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">basedir</span><span class="p">,</span> <span class="s2">&quot;reconstructed&quot;</span><span class="p">)</span>
        <span class="n">os</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="n">direp</span><span class="p">)</span>
        <span class="n">single_final_pdb</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="n">mr_llg</span> <span class="o">=</span> <span class="n">dictiosol</span><span class="p">[</span><span class="s2">&quot;llg&quot;</span><span class="p">]</span>
        <span class="n">ensemap</span> <span class="o">=</span> <span class="n">solutionmtz</span>

        <span class="n">solufixs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">pdb_structure</span><span class="o">.</span><span class="n">extract_single_components_from_solution</span><span class="p">(</span><span class="n">solutionpdb</span><span class="p">)</span>
        <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;sol&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="n">prepare</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">basedir</span><span class="p">,</span> <span class="s2">&quot;prepare&quot;</span><span class="p">)</span>
        <span class="n">os</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="n">prepare</span><span class="p">)</span>
        <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;workingdir&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">prepare</span>
        <span class="k">for</span> <span class="n">nnx</span><span class="p">,</span> <span class="n">fx</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">solufixs</span><span class="p">):</span>
            <span class="n">ppp</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">pdb_structure</span><span class="o">.</span><span class="n">PDB</span><span class="p">(</span><span class="n">fx</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">w</span><span class="p">,</span> <span class="n">model</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">ppp</span><span class="o">.</span><span class="n">structure</span><span class="p">):</span>
                <span class="n">pdbf</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">prepare</span><span class="p">,</span> <span class="s2">&quot;fx&quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">nnx</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot;.pdb&quot;</span><span class="p">)</span>
                <span class="n">ppp</span><span class="o">.</span><span class="n">get_pdb_from_list_of_atoms</span><span class="p">(</span><span class="n">extract_only_models</span><span class="o">=</span><span class="p">[</span><span class="n">w</span><span class="p">],</span> <span class="n">write_pdb</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">path_output_pdb</span><span class="o">=</span><span class="n">pdbf</span><span class="p">)</span>
                <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;sol&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">append</span><span class="p">({</span><span class="s2">&quot;modlid&quot;</span><span class="p">:</span> <span class="s2">&quot;fx&quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">nnx</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot;.pdb&quot;</span><span class="p">,</span> <span class="s2">&quot;pdb&quot;</span><span class="p">:</span> <span class="n">pdbf</span><span class="p">,</span> <span class="s2">&quot;identity&quot;</span><span class="p">:</span> <span class="mf">1.0</span><span class="p">})</span>
                <span class="k">break</span>

        <span class="n">result</span> <span class="o">=</span> <span class="n">phaser_wrapper</span><span class="o">.</span><span class="n">start_MR_RNP</span><span class="p">(</span><span class="n">inputs</span><span class="p">,</span> <span class="n">pickling</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">already_in_place</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
        <span class="n">llg</span> <span class="o">=</span> <span class="n">result</span><span class="o">.</span><span class="n">getTopLLG</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;SHIFT: Single model of multi ensembles, llg &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">llg</span><span class="p">))</span>
        <span class="n">solutionpdb</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">basedir</span><span class="p">,</span> <span class="s2">&quot;modelforshift.pdb&quot;</span><span class="p">)</span>
        <span class="n">shutil</span><span class="o">.</span><span class="n">copyfile</span><span class="p">(</span><span class="n">result</span><span class="o">.</span><span class="n">getTopPdbFile</span><span class="p">(),</span><span class="n">solutionpdb</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;SHIFT: SHIFTFIELD OF &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">solutionpdb</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot; MAP &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">ensemap</span><span class="p">))</span>

        <span class="n">minrfree</span> <span class="o">=</span> <span class="mi">100</span>
        <span class="c1"># for cycle in [100]:</span>
        <span class="c1">#     for low in [80, 70, 50, 30]:</span>
        <span class="c1">#         for high in [5]:</span>
        <span class="c1"># inputs[&quot;sol&quot;] = [{&quot;pdb&quot;:solutionpdb, &quot;id&quot;:None, &quot;euler&quot;: [0.0, 0.0, 0.0], &quot;frac&quot;: [0.0, 0.0, 0.0],</span>
        <span class="c1">#                    &quot;bfac&quot;: resultRNP.getTopSet().KNOWN[0].BFAC,</span>
        <span class="c1">#                    &quot;mult&quot;: resultRNP.getTopSet().KNOWN[0].MULT,</span>
        <span class="c1">#                    &quot;ofac&quot;: resultRNP.getTopSet().KNOWN[0].OFAC}]</span>

        <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">shiftedpdb</span><span class="p">):</span> <span class="n">os</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">shiftedpdb</span><span class="p">)</span>

        <span class="k">try</span><span class="p">:</span>
            <span class="n">best_update</span> <span class="o">=</span> <span class="kc">None</span>
            <span class="k">for</span> <span class="n">update</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">13</span><span class="p">,</span><span class="mi">1</span><span class="p">):</span>
                <span class="n">e</span> <span class="o">=</span> <span class="n">shift_field_refinement</span><span class="o">.</span><span class="n">shift_field</span><span class="p">(</span><span class="n">ensemap</span><span class="p">,</span> <span class="n">title</span><span class="o">=</span><span class="s2">&quot;shift field refinement&quot;</span><span class="p">,</span>
                                                       <span class="n">ipcolfo</span><span class="o">=</span><span class="n">label1</span> <span class="o">+</span> <span class="s2">&quot;,&quot;</span> <span class="o">+</span> <span class="n">label2</span><span class="p">,</span>
                                                       <span class="n">ipcolfree</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                                                       <span class="n">pdbfile</span><span class="o">=</span><span class="n">solutionpdb</span><span class="p">,</span>
                                                       <span class="n">pdbmask</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">pdboutfile</span><span class="o">=</span><span class="n">shiftedpdb</span><span class="p">,</span>
                                                       <span class="n">ncyc</span><span class="o">=</span><span class="mi">100</span><span class="p">,</span> <span class="n">freeflag</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">refxyz</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                                                       <span class="n">refuiso</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">rad</span><span class="o">=-</span><span class="mf">1.0</span><span class="p">,</span>
                                                       <span class="n">radscl</span><span class="o">=</span><span class="mf">1.0</span><span class="p">,</span> <span class="n">res</span><span class="o">=-</span><span class="mf">1.0</span><span class="p">,</span> <span class="n">resbycyc</span><span class="o">=</span><span class="p">[],</span>
                                                       <span class="n">aniso</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="nb">filter</span><span class="o">=</span><span class="s2">&quot;quadratic&quot;</span><span class="p">,</span>
                                                       <span class="n">n_refln</span><span class="o">=</span><span class="mi">1000</span><span class="p">,</span> <span class="n">n_param</span><span class="o">=</span><span class="mi">20</span><span class="p">,</span> <span class="n">use_phaser</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                                                       <span class="n">resmethod</span><span class="o">=</span><span class="s2">&quot;auto&quot;</span><span class="p">,</span> <span class="n">update_low</span><span class="o">=</span><span class="n">update</span><span class="p">,</span> <span class="n">labels_fc</span><span class="o">=</span><span class="s2">&quot;FC,PHIC&quot;</span><span class="p">,</span>
                                                       <span class="n">labels_fd</span><span class="o">=</span><span class="s2">&quot;DELFWT,PHDELWT&quot;</span><span class="p">)</span>  <span class="c1"># **kwargs</span>

                <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Starting a new cycle with update &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">update</span><span class="p">))</span>
                <span class="n">rmsd</span><span class="p">,</span> <span class="n">R</span><span class="p">,</span> <span class="n">t</span><span class="p">,</span> <span class="n">st1</span><span class="p">,</span> <span class="n">st2</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">shift</span><span class="p">(</span><span class="n">e</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="n">solutionpdb</span><span class="p">,</span> <span class="n">basedir</span><span class="p">)</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;SHIFT has produced an rmsd of &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">rmsd</span><span class="p">))</span>
                <span class="k">if</span> <span class="n">rmsd</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">rmsd</span> <span class="o">&lt;=</span> <span class="n">MAX_TRESHOLD_RMSD</span><span class="p">:</span>
                    <span class="n">best_update</span> <span class="o">=</span> <span class="n">update</span>
                    <span class="k">break</span>

            <span class="k">if</span> <span class="n">best_update</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Shift field cannot produce a valid shifted coordinate model. Skipping&quot;</span><span class="p">)</span>
                <span class="k">return</span> <span class="kc">None</span><span class="p">,</span><span class="kc">None</span><span class="p">,</span><span class="kc">None</span><span class="p">,</span><span class="kc">None</span>

            <span class="k">for</span> <span class="n">ncyc</span> <span class="ow">in</span> <span class="p">[</span><span class="mi">50</span><span class="p">,</span> <span class="mi">100</span><span class="p">,</span> <span class="mi">300</span><span class="p">,</span> <span class="mi">500</span><span class="p">]:</span>
                <span class="n">prev_shifted</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">basedir</span><span class="p">,</span><span class="s2">&quot;finalshift.pdb&quot;</span><span class="p">)</span>
                <span class="n">remarks1</span> <span class="o">=</span> <span class="kc">None</span>
                <span class="n">e</span> <span class="o">=</span> <span class="n">shift_field_refinement</span><span class="o">.</span><span class="n">shift_field</span><span class="p">(</span><span class="n">ensemap</span><span class="p">,</span> <span class="n">title</span><span class="o">=</span><span class="s2">&quot;shift field refinement&quot;</span><span class="p">,</span>
                                                       <span class="n">ipcolfo</span><span class="o">=</span><span class="n">label1</span> <span class="o">+</span> <span class="s2">&quot;,&quot;</span> <span class="o">+</span> <span class="n">label2</span><span class="p">,</span>
                                                       <span class="n">ipcolfree</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                                                       <span class="n">pdbfile</span><span class="o">=</span><span class="n">solutionpdb</span><span class="p">,</span>
                                                       <span class="n">pdbmask</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">pdboutfile</span><span class="o">=</span><span class="n">shiftedpdb</span><span class="p">,</span>
                                                       <span class="n">ncyc</span><span class="o">=</span><span class="n">ncyc</span><span class="p">,</span> <span class="n">freeflag</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">refxyz</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                                                       <span class="n">refuiso</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">rad</span><span class="o">=-</span><span class="mf">1.0</span><span class="p">,</span>
                                                       <span class="n">radscl</span><span class="o">=</span><span class="mf">1.0</span><span class="p">,</span> <span class="n">res</span><span class="o">=-</span><span class="mf">1.0</span><span class="p">,</span> <span class="n">resbycyc</span><span class="o">=</span><span class="p">[],</span>
                                                       <span class="n">aniso</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="nb">filter</span><span class="o">=</span><span class="s2">&quot;quadratic&quot;</span><span class="p">,</span>
                                                       <span class="n">n_refln</span><span class="o">=</span><span class="mi">1000</span><span class="p">,</span> <span class="n">n_param</span><span class="o">=</span><span class="mi">20</span><span class="p">,</span> <span class="n">use_phaser</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                                                       <span class="n">resmethod</span><span class="o">=</span><span class="s2">&quot;auto&quot;</span><span class="p">,</span> <span class="n">update_low</span><span class="o">=</span><span class="n">best_update</span><span class="p">,</span> <span class="n">labels_fc</span><span class="o">=</span><span class="s2">&quot;FC,PHIC&quot;</span><span class="p">,</span>
                                                       <span class="n">labels_fd</span><span class="o">=</span><span class="s2">&quot;DELFWT,PHDELWT&quot;</span><span class="p">)</span>  <span class="c1"># **kwargs</span>

                <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Starting a new cycle with update &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">best_update</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot; and ncycles &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">ncyc</span><span class="p">))</span>
                <span class="k">for</span> <span class="n">cyc</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">ncyc</span><span class="p">):</span>
                    <span class="n">rmsd</span><span class="p">,</span> <span class="n">R</span><span class="p">,</span> <span class="n">t</span><span class="p">,</span> <span class="n">st1</span><span class="p">,</span> <span class="n">st2</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">shift</span><span class="p">(</span><span class="n">e</span><span class="p">,</span> <span class="n">cyc</span><span class="p">,</span> <span class="n">solutionpdb</span><span class="p">,</span> <span class="n">basedir</span><span class="p">)</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;SHIFT has produced an rmsd of &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">rmsd</span><span class="p">))</span>
                    <span class="k">if</span> <span class="n">rmsd</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">or</span> <span class="n">rmsd</span> <span class="o">&gt;</span> <span class="n">MAX_TRESHOLD_RMSD</span><span class="p">:</span>
                        <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Shift is too large. Skipping&quot;</span><span class="p">)</span>
                        <span class="k">break</span>
                    <span class="k">else</span><span class="p">:</span>
                        <span class="n">shutil</span><span class="o">.</span><span class="n">copyfile</span><span class="p">(</span><span class="n">shiftedpdb</span><span class="p">,</span> <span class="n">prev_shifted</span><span class="p">)</span>
                        <span class="n">remarks1</span> <span class="o">=</span> <span class="n">st1</span><span class="o">.</span><span class="n">remarks</span>

                <span class="k">if</span> <span class="ow">not</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">prev_shifted</span><span class="p">):</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot; &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">prev_shifted</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot; does not exists skip test&quot;</span><span class="p">)</span>
                    <span class="k">continue</span>

                <span class="n">st2</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">pdb_structure</span><span class="o">.</span><span class="n">PDB</span><span class="p">(</span><span class="n">prev_shifted</span><span class="p">)</span>
                <span class="n">st2</span><span class="o">.</span><span class="n">get_pdb_from_list_of_atoms</span><span class="p">(</span><span class="n">write_pdb</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">path_output_pdb</span><span class="o">=</span><span class="n">st2</span><span class="o">.</span><span class="n">filepath</span><span class="p">,</span>
                                               <span class="n">header</span><span class="o">=</span><span class="n">remarks1</span><span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="n">st2</span><span class="o">.</span><span class="n">remarks</span><span class="p">)</span>

                <span class="c1">#TODO: How to establish what should be the identity of the rms here? shift field</span>
                <span class="c1">#have moved the things so how we should establish the correct new value?</span>
                <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;sol&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="p">[{</span><span class="s2">&quot;modlid&quot;</span><span class="p">:</span> <span class="s2">&quot;shifted&quot;</span><span class="p">,</span> <span class="s2">&quot;pdb&quot;</span><span class="p">:</span><span class="n">prev_shifted</span><span class="p">,</span> <span class="s2">&quot;identity&quot;</span><span class="p">:</span><span class="mf">1.0</span><span class="p">}]</span>

                <span class="n">result</span> <span class="o">=</span> <span class="n">phaser_wrapper</span><span class="o">.</span><span class="n">start_MR_RNP</span><span class="p">(</span><span class="n">inputs</span><span class="p">,</span> <span class="n">pickling</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">already_in_place</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
                <span class="n">llg</span> <span class="o">=</span> <span class="n">result</span><span class="o">.</span><span class="n">getTopLLG</span><span class="p">()</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;SHIFT: RNP OF &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">prev_shifted</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot; llg &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">llg</span><span class="p">))</span>
                <span class="n">zscore</span> <span class="o">=</span> <span class="n">result</span><span class="o">.</span><span class="n">getTopTFZ</span><span class="p">()</span>
                <span class="k">return</span> <span class="n">result</span><span class="o">.</span><span class="n">getTopPdbFile</span><span class="p">(),</span><span class="n">result</span><span class="o">.</span><span class="n">getTopMtzFile</span><span class="p">(),</span><span class="n">llg</span><span class="p">,</span><span class="n">zscore</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">exc_info</span><span class="p">())</span>
            <span class="n">traceback</span><span class="o">.</span><span class="n">print_exc</span><span class="p">(</span><span class="n">file</span><span class="o">=</span><span class="n">sys</span><span class="o">.</span><span class="n">stdout</span><span class="p">)</span>

        <span class="k">return</span> <span class="kc">None</span><span class="p">,</span><span class="kc">None</span><span class="p">,</span><span class="kc">None</span><span class="p">,</span><span class="kc">None</span></div>


<div class="viewcode-block" id="ShiftFieldRefinement.shift"><a class="viewcode-back" href="../../../Voyager.Actions.ShiftFieldRefinement.html#Voyager.Actions.ShiftFieldRefinement.ShiftFieldRefinement.shift">[docs]</a>    <span class="k">def</span> <span class="nf">shift</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">e</span><span class="p">,</span> <span class="n">cycle</span><span class="p">,</span> <span class="n">solutionpdb</span><span class="p">,</span> <span class="n">basedir</span><span class="p">):</span>
        <span class="n">shiftedpdb</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">basedir</span><span class="p">,</span> <span class="s2">&quot;shifted.pdb&quot;</span><span class="p">)</span>
        <span class="n">e</span><span class="o">.</span><span class="n">one_cycle</span><span class="p">(</span><span class="n">cycle</span><span class="p">,</span> <span class="n">write_pdb</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

        <span class="k">if</span> <span class="ow">not</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">shiftedpdb</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;SHIFT FIELD has not produced a valid pdb. Skipping&quot;</span><span class="p">)</span>
            <span class="k">return</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span>

        <span class="n">st1</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">pdb_structure</span><span class="o">.</span><span class="n">PDB</span><span class="p">(</span><span class="n">solutionpdb</span><span class="p">)</span>
        <span class="n">st2</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">pdb_structure</span><span class="o">.</span><span class="n">PDB</span><span class="p">(</span><span class="n">shiftedpdb</span><span class="p">)</span>

        <span class="n">atoms1</span> <span class="o">=</span> <span class="n">st1</span><span class="o">.</span><span class="n">get_list_of_atoms</span><span class="p">()</span>
        <span class="n">atoms2</span> <span class="o">=</span> <span class="n">st2</span><span class="o">.</span><span class="n">get_list_of_atoms</span><span class="p">()</span>

        <span class="k">assert</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">atoms1</span><span class="p">)</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">atoms2</span><span class="p">))</span>

        <span class="n">rmsd</span><span class="p">,</span> <span class="n">R</span><span class="p">,</span> <span class="n">t</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">pdb_structure</span><span class="o">.</span><span class="n">get_rmsd_and_RT</span><span class="p">(</span><span class="n">atoms1</span><span class="p">,</span> <span class="n">atoms2</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">rmsd</span><span class="p">,</span> <span class="n">R</span><span class="p">,</span> <span class="n">t</span><span class="p">,</span> <span class="n">st1</span><span class="p">,</span> <span class="n">st2</span></div></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" >Module code</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Massimo D. Sammito.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.
    </div>
  </body>
</html>